# Welcome to BSD Owl Scripts wiki!

This collection of BSD Make directives aims at providing a highly
portable build system targetting modern UNIX systems and supporting
common or less command languages.

It can already be used to:
- Preparation and publication of TeX documents;
- Development of TeX macros with NOWEB;
- Development of OCaml software;
- Maintainance of a FreeBSD workstation configuration files;
- Preparation of a static website with ONSGMLS.

It is well tested under:
- Mac OS X, version 10.6.8 and above
- FreeBSD, version 9.0 and above
- Debian Jessie and newer

It is hoped to function well under several other operating systems
such as NetBSD, OpenBSD and other Linuces. See our [compatibility
list][Compatibility].  It seems to also work under
[Cygwin][CompatibilityCygwin].


## Starting points for users

The file `README.md` contains instructions to [[Download]] and
[[Install]] the package and your are now probably interested in
getting started:

- Learn to [[ProduceLaTeXDocuments]] documents, with support for
  METAPOST figures, bibliographies, and documents spreading acroess
  several files or directories (like a thesis).

- Useful scripts support you if you [[DevelopOCamlSoftware]] taking
  care of the compilation of programs, libraries and toplevels.
  Dependencies are automatically generated with `ocamldep` and
  parallel builds are supported.

- As a UNIX user you are likely to [[DevelopShellScripts]] or to have
  several [configuration files](ManageDotFiles) so we help
  you taking care of them.


## Starting points for developers and porters

Be sure to [setup your environment appropriately][Developer] and to
read the [short description of concepts][Concepts] for our build
system.  Happy hacking!
